require 'tagstand'
require 'json'

module Tagstand
  # Represents a tag
  class Tag
    class << self
      
      # TODO: document this method
      # TODO: POST body causing error
      def create(tag=nil)
        options = {query: {api_key: Tagstand.api_key}}
        options.merge!(body: "tag=#{tag.to_json}") if tag
        response = Tagstand.post "/tag_create", options
        Hashie::Mash.new(response)
      end
      
      # TODO: document this method
      # id can be either a number (Int) or URL key (String)
      def destroy(id)
        query = {api_key: Tagstand.api_key}
        ident = id.is_a?(Integer) ? {number: id} : {url_key: id}
        query.merge!(ident)
        options = {query: query}
        response = Tagstand.get "/tag_destroy", options
        Hashie::Mash.new(response)
      end
      
      # TODO: document this method
      # Args: order, name_prefix_filter, data_type_filter, number_filter, page, num_per_page
      def list(args={})
        options = {query: {api_key: Tagstand.api_key}}
        options.merge!(args) unless args.empty?
        response = Tagstand.get "/tag_list", options
        Hashie::Mash.new(response)
      end
      
      # TODO: document this method
      # id can be either a number (Int) or URL key (String)
      def show(id)
        query = {api_key: Tagstand.api_key}
        ident = id.is_a?(Integer) ? {number: id} : {url_key: id}
        query.merge!(ident)
        options = {query: query}
        response = Tagstand.get "/tag_show", options
        Hashie::Mash.new(response)
      end
      
      # TODO: document this method
      # id can be either a number (Int) or URL key (String)
      # TODO: POST body causing error
      def update(id, tag=nil)
        query = {api_key: Tagstand.api_key}
        ident = id.is_a?(Integer) ? {number: id} : {url_key: id}
        query.merge!(ident)
        options = {query: query}
        options.merge!(body: "tag=#{tag.to_json}") if tag
        response = Tagstand.post "/tag_update", options
        Hashie::Mash.new(response)
      end
      
    end
  end
end